﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace ListViewSort {
    public partial class Form1 : Form {
        int _previouslySortedColumn = -1;


        public Form1() {
            InitializeComponent();
        }

        void listview1_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e) {
            
            ListViewComparer lvComparer ;

            if (null == listview1.ListViewItemSorter) 
            {
                lvComparer = new ListViewComparer();
            } else {
                lvComparer = (ListViewComparer) listview1.ListViewItemSorter;
            }

            if (e.Column != _previouslySortedColumn) {
                listview1.Sorting = SortOrder.None;
            }
            if (listview1.Sorting == SortOrder.Ascending) {
                listview1.Sorting = SortOrder.Descending;
            } else {
                listview1.Sorting = SortOrder.Ascending;
            }
            
            LVSort.SetSortIcons(listview1, ref _previouslySortedColumn, e.Column);
            lvComparer.SortColumn = e.Column;
            listview1.ListViewItemSorter = (System.Collections.IComparer) lvComparer; //this immediately causes a sort to happen

        
              
        }

        private void LinkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e) {
            System.Diagnostics.Process.Start("http://www.thebitguru.com/articles/16-");
        }
    }
}
